
; ========================
;
;                Multiple Document Interface
;
; ========================

; =========== Preamble ===========

        .586                                ; create 32 bit code
        .MODEL  Flat,StdCall                ; 32 bit memory model
        OPTION  CaseMap:None                ; case sensitive

; =========== Includes ===========

        .XCREF
        .NOLIST
        INCLUDE    \masm32\include\windows.inc
        INCLUDE    \masm32\include\kernel32.inc
        INCLUDE    \masm32\include\shell32.inc
        INCLUDE    \masm32\include\user32.inc
        INCLUDE    \masm32\include\comctl32.inc
        INCLUDE    \masm32\include\comdlg32.inc
        INCLUDE    \masm32\include\gdi32.inc
        INCLUDE    \masm32\include\oleaut32.inc
        INCLUDE    \masm32\include\msvcrt.inc
        INCLUDE    \masm32\include\masm32.inc
        INCLUDE    \masm32\macros\macros.asm

        INCLUDELIB \masm32\lib\kernel32.lib
        INCLUDELIB \masm32\lib\shell32.lib
        INCLUDELIB \masm32\lib\user32.lib
        INCLUDELIB \masm32\lib\comctl32.lib
        INCLUDELIB \masm32\lib\comdlg32.lib
        INCLUDELIB \masm32\lib\gdi32.lib
        INCLUDELIB \masm32\lib\oleaut32.lib
        INCLUDELIB \masm32\lib\msvcrt.lib
        INCLUDELIB \masm32\lib\masm32.lib
        .LIST

; =========== Prototypes ===========

WndProc         PROTO    :HWND,:UINT,:WPARAM,:LPARAM
ChildProc       PROTO    :HWND,:UINT,:WPARAM,:LPARAM

; =========== Equates ===========

IDI_ICON                 EQU 600
IDM_MAINMENU             EQU 1000
IDM_FILENEW              EQU 1101
IDM_FILEARRANGE_CASCADE  EQU 1121
IDM_FILEARRANGE_TILEHORZ EQU 1122
IDM_FILEARRANGE_TILEVERT EQU 1123
IDM_FILEARRANGE_ICONS    EQU 1124
IDM_FILEEXIT             EQU 1103
IDA_ACC                  EQU 1999
IDW_FIRSTCHILD           EQU 2000

; =========== Initialized Data ===========

        .DATA

nChildCount   dd 1

szFrameTitle  db 'Window Forge',0
szChildTitle  db 'MDI Child Window',0
szFrameClass  db 'ForgeFrameClass',0
szClientClass db 'MDICLIENT',0
szChildClass  db 'ForgeChildClass',0

; =========== Uninitialized Data ===========

        .DATA?

lpszCmdLine   dd ?
hInstance     dd ?
hWin          dd ?
hClient       dd ?
hMenu         dd ?
hAccel        dd ?

wc            WNDCLASSEX <>
msg           MSG <>
ccs           CLIENTCREATESTRUCT <>
mcs           MDICREATESTRUCT <>

; =========== Code ============================================================================

        .CODE

; =========== Frame Window Proc ===========

WndProc PROC    hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

;WM_CREATE

	.if uMsg==WM_CREATE
            push    ebx
            push    esi
            push    edi

            ; =========== Initialize CLIENTCREATESTRUCT structure ===========

            mov     ebx,hWnd
            mov     esi,offset ccs
            xor     edi,edi
            mov     hWin,ebx
            INVOKE  GetMenu,ebx
            mov     hMenu,eax
            INVOKE  GetSubMenu,eax,edi
            mov     [esi].CLIENTCREATESTRUCT.hWindowMenu,eax
            mov     [esi].CLIENTCREATESTRUCT.idFirstChild,IDW_FIRSTCHILD

            ; =========== Create client window ===========

            mov     eax,hInstance
            xchg    eax,ebx
            INVOKE  CreateWindowEx,edi,offset szClientClass,edi,
                    WS_CHILD or WS_VISIBLE or WS_CLIPCHILDREN,
                    CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
                    eax,edi,ebx,esi
            mov     hClient,eax

            ; =========== Initialize MDICREATESTRUCT structure ===========

            mov     esi,offset mcs
            mov     edx,CW_USEDEFAULT
            mov     [esi].MDICREATESTRUCT.szClass,offset szChildClass
            mov     [esi].MDICREATESTRUCT.szTitle,offset szChildTitle
            mov     [esi].MDICREATESTRUCT.hOwner,ebx
            mov     [esi].MDICREATESTRUCT.x,edx
            mov     [esi].MDICREATESTRUCT.y,edx
            mov     [esi].MDICREATESTRUCT.lx,edx
            mov     [esi].MDICREATESTRUCT.ly,edx
            mov     [esi].MDICREATESTRUCT.style,MDIS_ALLCHILDSTYLES or WS_HSCROLL or WS_VSCROLL
            mov     [esi].MDICREATESTRUCT.lParam,edi

            ; =========== Load keyboard accelerators ===========

            INVOKE  LoadAccelerators,ebx,IDA_ACC
            mov     hAccel,eax
            pop     edi
            pop     esi
            pop     ebx

;WM_COMMAND

        .elseif uMsg==WM_COMMAND
            mov eax,wParam
            xor ecx,ecx                                               ;ECX = 0
            and eax,0FFFEFFFFh                                        ;clear accelerator bit
            mov edx,hClient                                           ;EDX = hClient
                .if eax==IDM_FILENEW
                    INVOKE  SendMessage,edx,WM_MDICREATE,ecx,addr mcs
                    inc dword ptr nChildCount
                .elseif eax==IDM_FILEARRANGE_CASCADE
                    INVOKE  SendMessage,edx,WM_MDICASCADE,MDITILE_SKIPDISABLED,ecx
                .elseif eax==IDM_FILEARRANGE_TILEHORZ
                    INVOKE  SendMessage,edx,WM_MDITILE,MDITILE_HORIZONTAL,ecx
                .elseif eax==IDM_FILEARRANGE_TILEVERT
                    INVOKE  SendMessage,edx,WM_MDITILE,MDITILE_VERTICAL,ecx
                .elseif eax==IDM_FILEARRANGE_ICONS
                    INVOKE  ArrangeIconicWindows,edx
                .elseif eax==IDM_FILEEXIT
                    INVOKE  SendMessage,hWnd,WM_CLOSE,ecx,ecx
                .else
                    jmp short DefExit
                .endif

;WM_DESTROY

        .elseif uMsg==WM_DESTROY
            INVOKE  PostQuitMessage,NULL
        .else

DefExit:    INVOKE  DefFrameProc,hWnd,hClient,uMsg,wParam,lParam
            ret
        .endif

        xor     eax,eax
        ret

WndProc ENDP

; =============================================================================================

; =========== Child Window Proc ===========

ChildProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

        .if uMsg==WM_CLOSE
            INVOKE  SendMessage,hClient,WM_MDIDESTROY,hWnd,0
            dec dword ptr nChildCount
        .else
            INVOKE DefMDIChildProc,hWnd,uMsg,wParam,lParam
            ret
        .endif

        xor     eax,eax
	ret

ChildProc ENDP

; =============================================================================================

; =========== Main Proc ===========

WinMain PROC

; =========== Initialize globals ===========

        xor     edi,edi                                                   ;EDI = 0
        push    ICC_WIN95_CLASSES
        push    sizeof INITCOMMONCONTROLSEX
        INVOKE  InitCommonControlsEx,esp
        pop     ecx
        pop     edx
        INVOKE  GetCommandLine
        mov     lpszCmdLine,eax                                           ;store the command line address
        INVOKE  GetModuleHandle,edi
        mov     hInstance,eax                                             ;current application instance handle
        xchg    eax,ebx                                                   ;EBX = hInstance

; =========== Register frame window class ===========

        mov     esi,offset wc
        INVOKE  LoadCursor,edi,IDC_ARROW
        mov     [esi].WNDCLASSEX.hCursor,       eax                       ;predefined cursor
        INVOKE  LoadIcon,ebx,IDI_ICON
        mov     [esi].WNDCLASSEX.cbSize,        SIZEOF WNDCLASSEX
        mov     [esi].WNDCLASSEX.style,         CS_HREDRAW or CS_VREDRAW  ;CS_BYTEALIGNWINDOW not needed
        mov     [esi].WNDCLASSEX.lpfnWndProc,   WndProc
        mov     [esi].WNDCLASSEX.cbClsExtra,    edi
        mov     [esi].WNDCLASSEX.cbWndExtra,    edi                       ;extra memory not used, 40bytes max
        mov     [esi].WNDCLASSEX.hInstance,     ebx
        mov     [esi].WNDCLASSEX.hIcon,         eax
        mov     [esi].WNDCLASSEX.hbrBackground, NULL_BRUSH                ;paints nothing in client area
        mov     [esi].WNDCLASSEX.lpszMenuName,  IDM_MAINMENU
        mov     [esi].WNDCLASSEX.lpszClassName, offset szFrameClass
        mov     [esi].WNDCLASSEX.hIconSm,       eax
        INVOKE  RegisterClassEx,esi

; =========== Register child window class ===========

        mov     [esi].WNDCLASSEX.lpfnWndProc,   ChildProc
        mov     [esi].WNDCLASSEX.cbWndExtra,    32
        mov     [esi].WNDCLASSEX.hbrBackground, COLOR_BTNFACE+1           ;COLOR_APPWORKSPACE+1
        mov     [esi].WNDCLASSEX.lpszClassName, offset szChildClass
        INVOKE  RegisterClassEx,esi

; =========== Create frame window ===========

        INVOKE  CreateWindowEx,WS_EX_OVERLAPPEDWINDOW,offset szFrameClass,offset szFrameTitle,
                WS_OVERLAPPEDWINDOW or WS_VISIBLE or WS_CLIPCHILDREN or WS_HSCROLL or WS_VSCROLL,
                CW_USEDEFAULT,SW_SHOWNORMAL,600,440,edi,edi,ebx,edi
        xchg    eax,ebx                                                   ;EBX = hWin
        mov     ebp,hClient                                               ;EBP = hClient
        INVOKE  UpdateWindow,ebx
        INVOKE  SendMessage,ebp,WM_MDICREATE,edi,offset mcs

; =========== Message loop ===========

        mov     esi,offset msg                                            ;ESI = offset msg
        jmp short mLoop1

mLoop0: INVOKE  TranslateMDISysAccel,ebp,esi
        or      eax,eax
        jnz     mLoop1

        INVOKE  TranslateAccelerator,ebx,hAccel,esi
        or      eax,eax
        jnz     mLoop1
   
        INVOKE  TranslateMessage,esi
        INVOKE  DispatchMessage,esi

mLoop1: INVOKE  GetMessage,esi,edi,edi,edi
        neg     eax                                                       ;exit only
        shr     eax,1                                                     ;if 0 or -1
        jnz     mLoop0

        INVOKE  ExitProcess,[esi].MSG.wParam

WinMain ENDP

; =============================================================================================

        END     WinMain

